/*
   *Copyright:  

   ACEMod (2018--2021), The University of Sydney's invention disclosure CDIP Ref. 2019-123.
   Copyright   Oliver Cliff, Cameron Zachreson, Nathan Harding, Kristopher Fair, Mikhail Prokopenko, Mahendarajah Piraveenan

   AMTraC-19 (2020-201), The University of Sydney's invention disclosure CDIP 2020-018 (2020).
   Copyright   Sheryl Chang, Nathan Harding, Cameron Zachreson, Oliver Cliff, Mikhail Prokopenko

   This code is released only for internal review by Nature Communications, manuscript: NCOMMS-21-29568.

   *EndCopyright:
*/

#ifndef  CREATE_POPULATION_H_
#define  CREATE_POPULATION_H_

#include "agent.h"
#include "debug.h"
#include "utils.hpp"

#include <cmath>
#include <cstdarg>
#include <cstdlib>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <string>
#include <memory>

class CreatePopulation {

  private:

  	const static unsigned N_GRADES = 6;
  	const static unsigned N_TEACHERS_PER_CLASS = 3;
  	constexpr static double N_STUDENTS_PER_CLASS = 25.5;

    static void mapCD_SLA_DZ( cd_map_type&, dz_map_type&, sla_map_type&, const std::string& );

    static void mapWG_POW( wg_map_type&, wg_map_type&, dz_map_type&, const std::string& );

    static void addGradesAndClasses( agent_map_type&, wg_map_type&, wg_map_type&, wg_map_type& );

  public:
  	static const std::string school_grade_filename, school_student_filename;

    static void readPopulation( agent_map_type&, hh_map_type&, hc_map_type&,
                                  cd_map_type&, dz_map_type&, sla_map_type&,
                                  wg_map_type&, wg_map_type&, wg_map_type&, wg_map_type&,
                                  const std::string&, const std::string& );

};

#endif //CREATE_POPULATION_H_
