/*
   *Copyright:  

   ACEMod (2018--2021), The University of Sydney's invention disclosure CDIP Ref. 2019-123.
   Copyright   Oliver Cliff, Cameron Zachreson, Nathan Harding, Kristopher Fair, Mikhail Prokopenko, Mahendarajah Piraveenan

   AMTraC-19 (2020-201), The University of Sydney's invention disclosure CDIP 2020-018 (2020).
   Copyright   Sheryl Chang, Nathan Harding, Cameron Zachreson, Oliver Cliff, Mikhail Prokopenko

   This code is released only for internal review by Nature Communications, manuscript: NCOMMS-21-29568.

   *EndCopyright:
*/

#ifndef ENUMS_H_
#define ENUMS_H_

/* Seed Types */
namespace SeedTypes
{
	enum SEED_TYPES
	{
	  Airport = 0,
	  NumberOfSLAs = 1,
	  PopulationRandom = 2,
	};
};
typedef SeedTypes::SEED_TYPES SeedType;

/* Disease States */
/*
namespace DiseaseStates
{
	enum DISEASE_STATES
	{
	  StateSusceptible = 0,
	  StateLatent = 1,
	  StateIncubation = 2,
	  StateAsymptomatic = 3,
	  StateSymptomatic = 4,
	  StateRemoved = 5,
	  StateWithdrawn = 6
	};
};
typedef DiseaseStates::DISEASE_STATES DiseaseState;
*/

/* Disease States */
namespace DiseaseStates
{
	enum DISEASE_STATES
	{
	  StateSusceptible = 0,
	  StateAsymptomatic = 1,
	  StateSymptomatic = 2,
	  StateRemoved = 3,
	  StateWithdrawn = 4
	};
};
typedef DiseaseStates::DISEASE_STATES DiseaseState;

namespace AgeGroups
{
	enum AGE_GROUPS
	{
	  Age0to4 = 0,
	  Age5to18 = 1,
	  Age19to29 = 2,
	  Age30to64 = 3,
	  Age65Plus = 4
	};
};
typedef AgeGroups::AGE_GROUPS AgeGroup;

/*beginning Kit's edit 06.07.18 -intervention*/
namespace VacStates
{
	enum VAC_STATES
	{
		notvaccinated = 0,
		vaccinated_general = 1,
		vaccinated_priority = 2
	};
};

typedef VacStates::VAC_STATES VacState;
/*end Kit's edit 06.07.18 -intervention*/

/*beginning Kit's edit 09.07.18 - AVE*/
namespace AVStates
{
	enum AV_STATES
	{
		Notexposed = 0,
		ExposedNoAV = 1,
		ExposedAV = 2,
		AV_prophylaxis = 3,
		AV_treatment = 4,
		DetectedTreated = 5
	};
};

typedef AVStates::AV_STATES AVState;
/*end Kit's edit 09.07.18 - AVE*/


//CZ COV19 SD 17032020 - define SD states
namespace SD_States
{
	enum SD_STATES
	{
		SD_noncompliant = 0,
		SD_compliant = 1
	};
};

typedef SD_States::SD_STATES SD_State;

//CZ COV19 CI 24032020 - define CI states
namespace CI_States
{
	enum CI_STATES
	{
		CI_noncompliant = 0,
		CI_compliant = 1
	};
};

typedef CI_States::CI_STATES CI_State;


//CZ COV19 HQ 31032020 - define HQ states
namespace HQ_States
{
	enum HQ_STATES
	{
		HQ_noncompliant = 0,
		HQ_compliant = 1
	};
};

typedef HQ_States::HQ_STATES HQ_State;

namespace Compliance_States
{
	enum COMPLIANCE_STATES
	{
		nil = 0,
		SD = 1,
		SD_CI = 2,
		SD_CI_HQ = 3,
		CI_HQ = 4,
		CI = 5
	};
};

typedef Compliance_States::COMPLIANCE_STATES Compliance_State;

// Agent states for school closure
namespace SC_States
{
	enum SC_STATES
	{
		SC_nil = 0,
		SC_child = 1,
		SC_teacher = 2,
		SC_parent = 3
	};
};

typedef SC_States::SC_STATES SC_State;

//Agent states for isolation conditions
namespace Isolation_States
{
	enum ISOLATION_STATES
	{
		nil = 0,
		SD = 1,
		SC = 2,
		HQ = 3,
		CI = 4
	};
};

typedef Isolation_States::ISOLATION_STATES Isolation_State;

namespace WorkingGroupTypes
{
	enum WORKING_GROUP_TYPES
	{
	  Workplace = 0,
	  SchoolWhole = 1,
	  SchoolGrade = 2,
	  SchoolClass = 3
	};
};
typedef WorkingGroupTypes::WORKING_GROUP_TYPES WorkingGroupType;

namespace HouseholdSizeGroups
{
	enum HOUSEHOLD_SIZE_GROUPS
	{
	  TwoOrLessPeople = 0,
	  ThreePeople = 1,
	  FourPeople = 2,
	  FivePeople = 3,
	  SixOrMorePeople = 4
	};
};
typedef HouseholdSizeGroups::HOUSEHOLD_SIZE_GROUPS HouseholdSizeGroup;


namespace HouseholdCompositions
{
	enum HOUSEHOLD_COMPOSITIONS
	{
	  /* Single/lone household */
	  Single,
	  /* Couples without children */
	  CouplesWithoutChildren,
	  /* Couples with children */
	  CouplesWithOneChild, CouplesWithTwoChildren, CouplesWithThreeChildren, CouplesWithFourChildren,
	  /* Single parent families */
	  SingleParentFamilyOneChild, SingleParentFamilyTwoChildren, SingleParentFamilyThreeChildren,
	  SingleParentFamilyFourChildren, SingleParentFamilyFiveChildren,
	  /* Group houses */
	  GroupTwo, GroupThree, GroupFour, GroupFive, GroupSix };
};
typedef HouseholdCompositions::HOUSEHOLD_COMPOSITIONS HouseholdComposition;

namespace SexAgeGroups
{
	enum SEX_AGE_GROUPS
	{
	  M0to4, F0to4,
	  M5to18, F5to18,
	  M19to29, F19to29,
	  M30to64, F30to64,
	  M65Plus, F65Plus
	};
};
typedef SexAgeGroups::SEX_AGE_GROUPS SexAgeGroup;

namespace Sexes
{
	enum SEXES
	{
	  Male = 0,
	  Female = 1
	};
};
typedef Sexes::SEXES Sex;

namespace MixingGroups
{
	enum GROUPS
	{
	  GroupHousehold = 0,
	  GroupHouseholdCluster = 1,
	  GroupNeighbourhood = 2,
	  GroupCommunity = 3,
	  GroupWorkplace = 4,
	  GroupClass = 5,
	  GroupGrade = 6,
	  GroupSchool = 7
	};
};
typedef MixingGroups::GROUPS Group;

#endif // ENUMS_H_
